/* Copyright (c) 2006, NIF File Format Library and Tools
All rights reserved.  Please see niflib.h for licence. */

#ifndef _NIMORPHDATA_H_
#define _NIMORPHDATA_H_

#include "NiObject.h"
// Include structures
#include "../gen/Morph.h"

#include "../gen/obj_defines.h"

class NiMorphData;
typedef Ref<NiMorphData> NiMorphDataRef;

/*!
 * NiMorphData - Geometry morphing data.
 */

class NIFLIB_API NiMorphData : public NI_MORPH_DATA_PARENT {
public:
	NiMorphData();
	~NiMorphData();
	//Run-Time Type Information
	static const Type TYPE;
	virtual void Read( istream& in, list<uint> & link_stack, unsigned int version, unsigned int user_version );
	virtual void Write( ostream& out, map<NiObjectRef,uint> link_map, unsigned int version, unsigned int user_version ) const;
	virtual string asString( bool verbose = false ) const;
	virtual void FixLinks( const vector<NiObjectRef> & objects, list<uint> & link_stack, unsigned int version, unsigned int user_version );
	virtual list<NiObjectRef> GetRefs() const;
	virtual const Type & GetType() const;
protected:
	NI_MORPH_DATA_MEMBERS
};

#endif
